<template>
  <v-row>
    <v-col cols="12" sm="4">
      <Field #default="{ errors, field, value }" name="Email" rules="required|max:255|email" v-model="user.email">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="Email" density="compact"
          data-cy="UserFormEmailInput" :error-messages="errors" :disabled="!isNewUser" variant="outlined" class="required" color="primary">
        </v-text-field>
      </Field>
    </v-col>
    <v-col cols="12" sm="4">
      <Field #default="{ errors, field, value }" name="FirstName" rules="required|max:50" v-model="user.firstName">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="Prénom" density="compact"
          data-cy="UserFormFirstnameInput" :error-messages="errors" variant="outlined" class="required" color="primary">
        </v-text-field>
      </Field>
    </v-col>
    <v-col cols="12" sm="4">
      <Field #default="{ errors, field, value }" name="LastName" rules="required|max:50" v-model="user.lastName">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="Nom" density="compact"
          data-cy="UserFormLastnameInput" :error-messages="errors" variant="outlined" class="required" color="primary">
        </v-text-field>
      </Field>
    </v-col>
    <v-col cols="12" sm="4">
      <Field #default="{ errors, field, value }" name="Rank" v-model="user.rank">
        <v-autocomplete @update:model-value="field.onChange" :model-value="value" label="Grade" density="compact"
          data-cy="UserFormRankInput" :error-messages="errors" :items="ranks" :item-title="transformItem" variant="outlined"
          return-object color="primary">
        </v-autocomplete>
      </Field>
    </v-col>
    <v-col cols="12" sm="4">
      <Field #default="{ errors, field, value }" name="Unit" v-model="user.unit">
        <v-autocomplete @update:model-value="field.onChange" :model-value="value" label="Unité" density="compact"
          data-cy="UserFormUnitInput" :error-messages="errors" :items="units" item-title="name" variant="outlined" return-object color="primary">
        </v-autocomplete>
      </Field>
    </v-col>
    <v-col cols="12" sm="4">
      <Field #default="{ errors, field, value }" name="Role" rules="required" v-model="user.role">
        <v-select @update:model-value="field.onChange" :model-value="value" label="Rôle" density="compact"
          data-cy="UserFormRoleInput" :error-messages="errors" :items="userRoles" item-title="value" item-value="key"
          variant="outlined" class="required" color="primary">
        </v-select>
      </Field>
    </v-col>
  </v-row>
</template>

<script setup lang="ts">
import { computed } from "vue";
import { enumToObject } from "../../mixins/utilsMixin";
import { UserRole } from "~/dto/userRole.enum";
import { User } from "~/dto/user.dto";
import { Rank } from "~/dto/rank.dto";
import { Unit } from "~/dto/unit.dto";

defineProps<{
  user: User,
  isNewUser: boolean
}>();

const store = useStore();

const ranks: Ref<Rank[]> = computed(() => {
  return store.ranksLight;
});

const units: Ref<Unit[]> = computed(() => {
  const allUnits: Unit[] = store.unitsEnabled;
  switch (store.loggedInUser?.role) {
    case 'god':
      return allUnits;
    default:
      return allUnits.filter(u => u.id === store.loggedInUser?.unit?.id);
  }
});

const userRoles: Ref<any[]> = computed(() => {
  switch (store.loggedInUser?.role) {
    case 'god':
      return enumToObject(UserRole);
    case 'admin':
      return enumToObject(UserRole).filter((r) => r.value !== UserRole.god);
    default:
      return [];
  }
});

function transformItem(item: Rank) {
  return item.name + ' - ' + item.category
}

</script>
